using System;
using System.Collections.Generic;
using System.IO;
using System.Threading.Tasks;
using ELTE.TicTacToeGame.Droid.Persistence;
using ELTE.TicTacToeGame.Persistence;
using Xamarin.Forms;

[assembly: Dependency(typeof(AndroidStore))]
namespace ELTE.TicTacToeGame.Droid.Persistence
{
    /// <summary>
    /// Jtk trol megvalstsa Android platformra.
    /// </summary>
    public class AndroidStore : IStore
    {
        /// <summary>
        /// Fjlok lekrdezse.
        /// </summary>
        /// <returns>A fjlok listja.</returns>
        public async Task<IEnumerable<String>> GetFiles()
        {
            return await Task.Run(() => Directory.GetFiles(Environment.GetFolderPath(Environment.SpecialFolder.Personal)));
        }

        /// <summary>
        /// Mdosts idejnek lekrdezse.
        /// </summary>
        /// <param name="name">A fjl neve.</param>
        /// <returns>Az utols mdosts ideje.</returns>
        public async Task<DateTime> GetModifiedTime(String name)
        {
            FileInfo info = new FileInfo(Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.Personal), name));

            return await Task.Run(() => info.LastWriteTime);
        }
    }
}