﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using ELTE.TicTacToeGame.Persistence;
using ELTE.TicTacToeGame.Windows.Persistence;
using Windows.Storage;
using Xamarin.Forms;

[assembly: Dependency(typeof(WindowsStore))]
namespace ELTE.TicTacToeGame.Windows.Persistence
{
    /// <summary>
    /// Játék tároló megvalósítása Windows platformra.
    /// </summary>
    public class WindowsStore : IStore
    {
        /// <summary>
        /// Fájlok lekérdezése.
        /// </summary>
        /// <returns>A fájlok listája.</returns>
        public async Task<IEnumerable<String>> GetFiles()
        {
            IReadOnlyList<StorageFile> files = await ApplicationData.Current.LocalFolder.GetFilesAsync();
            return files.Select(file => file.Name);
        }

        /// <summary>
        /// Módosítás idejének lekrédezése.
        /// </summary>
        /// <param name="name">A fájl neve.</param>
        /// <returns>Az utolsó módosítás ideje.</returns>
        public async Task<DateTime> GetModifiedTime(String name)
        {
            StorageFile file = await ApplicationData.Current.LocalFolder.GetFileAsync(name);
            return (await file.GetBasicPropertiesAsync()).DateModified.DateTime;
        }
    }
}
